scala.util.control

# TailCalls

#### object TailCalls

Methods exported by this object implement tail calls via trampolining. Tail calling methods have to return their result using `done` or call the next method using `tailcall`. Both return a `TailRec` object. The result of evaluating a tailcalling function can be retrieved from a `Tailrec` value using method `result`. Implemented as described in "Stackless Scala with Free Monads" http://blog.higher-order.com/assets/trampolines.pdf

Here's a usage example:

    import scala.util.control.TailCalls._

    def isEven(xs: List[Int]): TailRec[Boolean] =
      if (xs.isEmpty) done(true) else tailcall(isOdd(xs.tail))

    def isOdd(xs: List[Int]): TailRec[Boolean] =
     if (xs.isEmpty) done(false) else tailcall(isEven(xs.tail))

    isEven((1 to 100000).toList).result

    def fib(n: Int): TailRec[Int] =
      if (n < 2) done(n) else for {
        x <- tailcall(fib(n - 1))
        y <- tailcall(fib(n - 2))
      } yield (x + y)

    fib(40).result

Source
  TailCalls.scala

Linear Supertypes
AnyRef, Any
Content Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. TailCalls
2. AnyRef
3. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### case class Call[A](rest: () ⇒ TailRec[A]) extends TailRec[A] with Product with Serializable

   Internal class representing a tailcall

   Internal class representing a tailcall

   Attributes
     protected

2. #### case class Cont[A, B](a: TailRec[A], f: (A) ⇒ TailRec[B]) extends TailRec[B] with Product with Serializable

   Internal class representing a continuation with function A => TailRec[B].

   Internal class representing a continuation with function A => TailRec[B]. It is needed for the flatMap to be implemented.

   Attributes
     protected

3. #### case class Done[A](value: A) extends TailRec[A] with Product with Serializable

   Internal class representing the final result returned from a tailcalling computation

   Internal class representing the final result returned from a tailcalling computation

   Attributes
     protected

4. #### abstract class TailRec[+A] extends AnyRef

   This class represents a tailcalling computation

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

5. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

6. #### def done[A](result: A): TailRec[A]

   Used to return final result from tailcalling computation

   Used to return final result from tailcalling computation

   returns

     a `TailRec` object representing a computation which immediately returns `result`

7. #### final def eq(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

8. #### def equals(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

9. #### def finalize(): Unit

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( classOf[java.lang.Throwable] )

10. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

11. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

12. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

13. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

14. #### final def notify(): Unit

    Definition Classes
      AnyRef

15. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

16. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

17. #### def tailcall[A](rest: ⇒ TailRec[A]): TailRec[A]

    Performs a tailcall

    Performs a tailcall

    rest

      the expression to be evaluated in the tailcall

    returns

      a `TailRec` object representing the expression `rest`

18. #### def toString(): String

    Definition Classes
      AnyRef → Any

19. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

20. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

21. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from AnyRef

### Inherited from Any

### Ungrouped